#include "validation.h"


int main(int argc, char *argv[]) {
	std::ifstream in(argv[1]);
	OutputValidator v(argc, argv);

	int year;
	in >> year;

	bool is_memorable = false;
	for (int b = 16; b > 1; b--)
		if (year % (b * b) == 0) 
			is_memorable = true;
	if (!is_memorable)
		v.test_string("impossible");
	else {
		int base = v.read_integer("base", 2, 16);
		v.space();
		std::string number = v.read_string("number", 3, 11, "0123456789abcdefABCDEF");
		if (number[0] == '0')
			v.WA("Leading 0");
		int decimal = 0;
		int power = 0;
		for (int i = number.length() - 1; i >= 0; i--) {
			char digit = number[i];
			int value;
			if (isdigit(digit)) {
				value = digit - '0';
			} else if (isalpha(digit)) {
				value = std::tolower(digit) - 'a' + 10;
			} else {
				v.WA("Invalid character");
			}
			if (value >= base) {
				v.WA("Digit out of bounds for base");
			}
			decimal += value * pow(base, power);
			power++;
		}	
		if (decimal != year) {
			char msg[100];
			std::snprintf(msg, 100, "Got %d, expected %d", year, decimal);
			v.WA(msg);
		}
	}
	v.newline();
}
