#!/usr/bin/env python3


from math import sqrt


def dist_sq(pts):
    p1, p2 = pts
    return (p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2


def trap(pts):
    p1, p2 = pts
    return 1 / 2 * (p2[1] + p1[1]) * (p2[0] - p1[0])


def main():
    n = int(input())

    points = [tuple(float(x) for x in input().split()) for _ in range(n)]

    area = sum(map(trap, zip(points, points[1:])))
    lengths_sq = sum(map(dist_sq, zip(points, points[1:])))

    if lengths_sq >= 1:
        frac_ar = 0
    else:
        frac_ar = area / (1 - lengths_sq)

    print(sqrt(3) / 4 + 3 * frac_ar)


if __name__ == "__main__":
    main()
