#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <charconv>
#include <cstring>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <limits>
#include <map>
#include <optional>
#include <random>
#include <set>
#include <stdexcept>
#include <string>
#include <string_view>
#include <type_traits>
#include <unordered_map>
#include <utility>
#include <variant>
#include <vector>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;

#define x first
#define y second
#define pb push_back
#define eb emplace_back
#define rep(i,a,b) for(auto i=(a); i<(b); ++i)
#define REP(i,n) rep(i,0,n)
#define all(v) (v).begin(), (v).end()
#define rs resize
#define DBG(x) cerr << __LINE__ << ": " << #x << " = " << (x) << endl

const ld PI = acos(-1.0);
template<class T> using min_queue =
priority_queue<T, vector<T>, greater<T>>;
template<class T> int sz(const T &x) {
    return (int) x.size(); // copy the ampersand(&)!
}

// START OF ACTUAL PROGRAM, START READING HERE

void run() {
	ll n, m, t;
	cin >> n >> m >> t;
	vector<vector<pair<ii,ii>>> adj(n);
	for (ll i = 0; i < m; i++) {
		ll x, y, l, v, w;
		cin >> x >> y >> l >> v >> w;
		x--; y--;
		adj[x].pb({{y,l},{v,w}});
		adj[y].pb({{x,l},{v,w}});
	}
	vector<ld> d(n, -1);
	priority_queue<pair<ld, ll>> Q;
	d[0] = 0;
	Q.push({0, 0});

	while (!Q.empty()) {
		pair<ld, ll> dk = Q.top(); Q.pop();
		ll k = dk.y;
		ld t0 = -dk.x;
		if (t0 > d[k]) continue;
		for (pair<ii,ii> p : adj[k]) {
			ll x = p.x.x; ld l = p.x.y, v = p.y.x, w = p.y.y;
			ld t1;
			if (t0 + l/v < t) {
				t1 = t0 + l/v;
			} else if (t0 >= t) {
				t1 = t0 + l/w;
			} else {
				t1 = t + (l-(t-t0)*v)/w;
			}
			if (d[x] < 0 || t1 < d[x]) {
				d[x] = t1;
				Q.push({-t1, x});
			}
		}
	}

	cout << d[n-1] << endl;


}

signed main() {
    // DON'T MIX "scanf" and "cin"!
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout << fixed << setprecision(20);
    run();
    return 0;
}
