#!/usr/bin/env python3
import sys

def solve(year):
    easy_bases = set(base for base in range(2, 17) if year % (base * base) == 0)
    if not easy_bases:
        return "impossible"
    else:
        result = []
        for base in easy_bases:
            base_string = "0123456789abcdef"
            easy = ""
            y = year
            while y:
                easy += base_string[y % base]
                y //= base
            result.append((base, easy[::-1]))
        return result


if len(sys.argv) > 1:
    for year in range(int(sys.argv[1]), int(sys.argv[2]) + 1):
        print(year, solve(year))
else:
    year = int(input().split()[0])
    answer = solve(year)
    if isinstance(answer, str):
        print(answer)
    else:
        print(*max(answer))
