
#include <iostream>
#include <random>

std::random_device rd;
std::mt19937 gen(rd());

int n, k, p;
std::bernoulli_distribution d;

int cont_trial() {return 1 + n - k + (4 + n) * d(gen);}
int back_trial() {return 2 + n - k + (4 + n) * (1 - d(gen));}
int rest_trial() {return 4 * n;}

int cont_sum(int N){
    int s = 0;
    for (int i = 0; i < N; ++i) s += cont_trial();
    return s;
}

int back_sum(int N){
    int s = 0;
    for (int i = 0; i < N; ++i) s += back_trial();
    return s;
}

const int trials = 1000000000;

int main(){
    std::cin >> n >> k >> p;
    d = std::bernoulli_distribution(p * 0.01L);
    int cont = cont_sum(trials), back = back_sum(trials), rest = trials * rest_trial();
    if (cont < back && cont < rest) std::cout << "continue" << std::endl;
    else if (back < rest) std::cout << "backspace" << std::endl;
    else std::cout << "restart" << std::endl;
    return 0;
}
