#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <charconv>
#include <cstring>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <limits>
#include <map>
#include <optional>
#include <random>
#include <set>
#include <stdexcept>
#include <string>
#include <string_view>
#include <type_traits>
#include <unordered_map>
#include <utility>
#include <variant>
#include <vector>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;

#define x first
#define y second
#define pb push_back
#define eb emplace_back
#define rep(i,a,b) for(auto i=(a); i<(b); ++i)
#define REP(i,n) rep(i,0,n)
#define all(v) (v).begin(), (v).end()
#define rs resize
#define DBG(x) cerr << __LINE__ << ": " << #x << " = " << (x) << endl

const ld PI = acos(-1.0);
template<class T> using min_queue =
priority_queue<T, vector<T>, greater<T>>;
template<class T> int sz(const T &x) {
    return (int) x.size(); // copy the ampersand(&)!
}

// START OF ACTUAL PROGRAM, START READING HERE
void run() {
	ll n;
	cin >> n;
	vi P(n), A(n);
	vector<string> S(n), T(n);
	unordered_map<ll, ll> Pm;
	for (ll i = 0; i < n; i++) {
		cin >> S[i] >> T[i] >> P[i] >> A[i];
	}
	priority_queue<pair<ll, pair<ll, ll>>> Bq, Sq;
	ll totB = 0, totS = 0;

	vector<pair<ii, ll>> R;
	for (ll i = 0; i < n; i++) {
		if (S[i][0] == 'b') {
			if (T[i][0] == 'f' && A[i] > totS) continue;
			ll totSc = 0;
			ll a = A[i];
			vector<pair<ll,ii>> Sdel;
			vector<pair<ii,ll>> Rcur;
			while (a > 0 && !Sq.empty() && P[i] >= -Sq.top().x) {
				auto s = Sq.top(); Sq.pop();
				Sdel.pb(s);
				ll ac = min(a, s.y.y);
				totSc += ac;
				Rcur.pb({{i, -s.y.x}, ac});
				if (s.y.y > ac) Sq.push({s.x, {s.y.x, s.y.y-ac}});
				a -= ac;
			}
			if (T[i][0] == 'n' || a == 0) {
				for (auto r : Rcur) R.pb(r);
				if (a > 0) Bq.push({P[i], {-i, a}});
				totS -= totSc;
				totB += a;
			} else {
				for (auto s : Sdel) Sq.push(s);
			}
		} else {
			if (T[i][0] == 'f' && A[i] > totB) continue;
			ll totBc = 0;
			ll a = A[i];
			vector<pair<ll,ii>> Bdel;
			vector<pair<ii,ll>> Rcur;
			while (a > 0 && !Bq.empty() && Bq.top().x >= P[i]) {
				auto b = Bq.top(); Bq.pop();
				Bdel.pb(b);
				ll ac = min(a, b.y.y);
				totBc += ac;
				Rcur.pb({{-b.y.x, i}, ac});
				if (b.y.y > ac) Bq.push({b.x, {b.y.x, b.y.y-ac}});
				a -= ac;
			}
			if (T[i][0] == 'n' || a == 0) {
				for (auto r : Rcur) R.pb(r);
				if (a > 0) Sq.push({-P[i], {-i, a}});
				totB -= totBc;
				totS += a;
			} else {
				for (auto b : Bdel) Bq.push(b);
			}
		}
	}

	cout << R.size() << endl;
	for (auto r : R) {
		cout << r.x.y+1 << " " << r.x.x+1 << " " << r.y << endl;
	}
}

signed main() {
    // DON'T MIX "scanf" and "cin"!
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout << fixed << setprecision(20);
    run();
    return 0;
}
