#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using num = unsigned long long;

// bad: no mod on intermediate computations
constexpr num M = 1e9 + 7;

int main() {
    int n;
    std::cin >> n;

    std::vector<bool> obstacle;
    for (int i = 0; i < n; i++) {
        char c;
        std::cin >> c;
        obstacle.push_back(c == '#');
    }

    const int maxJumpCount = std::sqrt(n*2);  // proof by Desmos (you can also simply use e.g. 500)
    std::vector<std::vector<num>> dp(n+1, std::vector<num>(maxJumpCount + 1));
    dp[0][0] = 1;
    for (int x = 0; x < n; x++) {
        if (!obstacle[x]) {
            for (int j = 0; j < maxJumpCount; j++) {
                // no jump
                dp[x+1][j] += dp[x][j];

                // yes jump
                const int y = std::min(x+j+2, n);
                dp[y][j+1] += dp[x][j];
            }
        }
    }

    long total = 0;
    for (const num a : dp.back()) total = (total + a) % M;
    std::cout << total << std::endl;
}
